/*******************************************************************************
* File Name: D_C.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_D_C_H) /* Pins D_C_H */
#define CY_PINS_D_C_H

#include "cytypes.h"
#include "cyfitter.h"
#include "D_C_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    D_C_Write(uint8 value) ;
void    D_C_SetDriveMode(uint8 mode) ;
uint8   D_C_ReadDataReg(void) ;
uint8   D_C_Read(void) ;
uint8   D_C_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define D_C_DRIVE_MODE_BITS        (3)
#define D_C_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - D_C_DRIVE_MODE_BITS))
#define D_C_DRIVE_MODE_SHIFT       (0x00u)
#define D_C_DRIVE_MODE_MASK        (0x07u << D_C_DRIVE_MODE_SHIFT)

#define D_C_DM_ALG_HIZ         (0x00u << D_C_DRIVE_MODE_SHIFT)
#define D_C_DM_DIG_HIZ         (0x01u << D_C_DRIVE_MODE_SHIFT)
#define D_C_DM_RES_UP          (0x02u << D_C_DRIVE_MODE_SHIFT)
#define D_C_DM_RES_DWN         (0x03u << D_C_DRIVE_MODE_SHIFT)
#define D_C_DM_OD_LO           (0x04u << D_C_DRIVE_MODE_SHIFT)
#define D_C_DM_OD_HI           (0x05u << D_C_DRIVE_MODE_SHIFT)
#define D_C_DM_STRONG          (0x06u << D_C_DRIVE_MODE_SHIFT)
#define D_C_DM_RES_UPDWN       (0x07u << D_C_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define D_C_MASK               D_C__MASK
#define D_C_SHIFT              D_C__SHIFT
#define D_C_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define D_C_PS                     (* (reg32 *) D_C__PS)
/* Port Configuration */
#define D_C_PC                     (* (reg32 *) D_C__PC)
/* Data Register */
#define D_C_DR                     (* (reg32 *) D_C__DR)
/* Input Buffer Disable Override */
#define D_C_INP_DIS                (* (reg32 *) D_C__PC2)


#if defined(D_C__INTSTAT)  /* Interrupt Registers */

    #define D_C_INTSTAT                (* (reg32 *) D_C__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins D_C_H */


/* [] END OF FILE */
